package com.kb.rest.client;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;

public class RestPostClient {
	public static void main(String[] args) {
		try {
			CloseableHttpClient  httpClient = HttpClients.createDefault();

			HttpPost postRequest = new HttpPost(
					"http://localhost:8080/RestWithHttpClient/rest/userInfo");

			String xmlHeader = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			String input = xmlHeader+"<User><id>1</id><name>Roy Thomas Fielding</name><age>51</age></User>";
			StringEntity inputEntity = new StringEntity(input);
			inputEntity.setContentType("application/xml");
			postRequest.setEntity(inputEntity);
			System.out.println(inputEntity);
				HttpResponse response = httpClient.execute(postRequest);
				if (response.getStatusLine().getStatusCode() != HttpStatus.SC_CREATED) {
					throw new RuntimeException("Request Processing Failed : HTTP error code : "
							   + response.getStatusLine().getStatusCode());
				}

				BufferedReader br = new BufferedReader(
		                        new InputStreamReader((response.getEntity().getContent())));

				String output;
				System.out.println("Output received from Rest service ....");
				while ((output = br.readLine()) != null) {
					System.out.println(output);
				}
				httpClient.close();
		  } catch (MalformedURLException e) {

			e.printStackTrace();

		  } catch (IOException e) {

			e.printStackTrace();

		 }
	}

}
